import (importPath.."ColorPicker");
-- need to create the options window
optionsWindow=Turbine.UI.Lotro.Window()
optionsWindow:SetSize(400,400)
optionsWindow:SetPosition((displayWidth-optionsWindow:GetWidth())/2,(displayHeight-optionsWindow:GetHeight())/2)

optionsWindow:SetText(Resource[language][4]);
	optionsWindow:SetVisible(false);
	optionsWindow:SetSize(540,360);
	optionsWindow:SetPosition((Turbine.UI.Display:GetWidth() - optionsWindow:GetWidth()) / 2,(Turbine.UI.Display:GetHeight() - optionsWindow:GetHeight()) / 2);

	optionsWindow.HadErrors=false;
	optionsWindow.OptionsPanel=Turbine.UI.Control();
	optionsWindow.OptionsPanel:SetParent(optionsWindow);
	optionsWindow.OptionsPanel:SetSize(optionsWindow:GetWidth()-30,optionsWindow:GetHeight()-80);
	optionsWindow.OptionsPanel:SetPosition(15,40);
	optionsWindow.OptionsPanel:SetBackColor(Settings.BackColor);

	optionsWindow.OptionsCaption=Turbine.UI.Label();
	optionsWindow.OptionsCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsWindow.OptionsCaption:SetSize(optionsWindow.OptionsPanel:GetWidth(),20);
	optionsWindow.OptionsCaption:SetPosition(0,0);
	optionsWindow.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsWindow.OptionsCaption:SetText(Resource[language][4]..":");

	optionsWindow.LanguageCaption=Turbine.UI.Label();
	optionsWindow.LanguageCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.LanguageCaption:SetPosition(10,optionsWindow.OptionsCaption:GetTop()+optionsWindow.OptionsCaption:GetHeight()+9);
	optionsWindow.LanguageCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.LanguageCaption:SetForeColor(Settings.FontColor);
	optionsWindow.LanguageCaption:SetText(Resource[language][5]..":");

	optionsWindow.LanguageList=DropDownList();
	optionsWindow.LanguageList:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.LanguageList:SetPosition(optionsWindow.LanguageCaption:GetLeft()+optionsWindow.LanguageCaption:GetWidth()+2,optionsWindow.LanguageCaption.GetTop()-3);
	optionsWindow.LanguageList:SetSize(optionsWindow.OptionsPanel:GetWidth()-(optionsWindow.LanguageCaption:GetWidth()+optionsWindow.LanguageCaption:GetLeft())-65,20);
	optionsWindow.LanguageList:SetBorderColor(Settings.TrimColor);
	optionsWindow.LanguageList:SetBackColor(Settings.BackColor);
	optionsWindow.LanguageList:SetCurrentBackColor(Settings.BackColor);
	optionsWindow.LanguageList:SetDropRows(5);
	optionsWindow.LanguageList:SetZOrder(1)

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		optionsWindow.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	optionsWindow.LanguageList.SelectedIndexChanged = function ()
		optionsWindow:SetLanguage(optionsWindow.LanguageList:GetValue());
	end

-- trim color
	optionsWindow.TrimCaption=Turbine.UI.Label();
	optionsWindow.TrimCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.TrimCaption:SetPosition(10,optionsWindow.LanguageCaption:GetTop()+optionsWindow.LanguageCaption:GetHeight()+9);
	optionsWindow.TrimCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.TrimCaption:SetForeColor(Settings.FontColor);
	optionsWindow.TrimCaption:SetText(Resource[language][6]..":");
	optionsWindow.TrimColor=ColorPicker();
	optionsWindow.TrimColor:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.TrimColor:SetPosition(optionsWindow.TrimCaption:GetLeft()+optionsWindow.TrimCaption:GetWidth()+5,optionsWindow.TrimCaption:GetTop()-1);
	optionsWindow.TrimColor:SetTrimColor(Settings.TrimColor);
	optionsWindow.TrimColor:SetColor(Settings.TrimColor);
	optionsWindow.TrimColor.ColorChanged=function()
		optionsWindow:SetTrimColor(optionsWindow.TrimColor:GetColor());
	end

	optionsWindow.BackCaption=Turbine.UI.Label();
	optionsWindow.BackCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.BackCaption:SetPosition(10,optionsWindow.TrimColor:GetTop()+optionsWindow.TrimColor:GetHeight()+9);
	optionsWindow.BackCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.BackCaption:SetForeColor(Settings.FontColor);
	optionsWindow.BackCaption:SetText(Resource[language][7]..":");
	optionsWindow.BackColor=ColorPicker();
	optionsWindow.BackColor:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.BackColor:SetPosition(optionsWindow.BackCaption:GetLeft()+optionsWindow.BackCaption:GetWidth()+5,optionsWindow.BackCaption:GetTop()-1);
	optionsWindow.BackColor:SetTrimColor(Settings.TrimColor);
	optionsWindow.BackColor:SetColor(Settings.BackColor);
	optionsWindow.BackColor.ColorChanged=function()
		optionsWindow:SetBackColor(optionsWindow.BackColor:GetColor());
	end

	optionsWindow.FontCaption=Turbine.UI.Label();
	optionsWindow.FontCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.FontCaption:SetPosition(10,optionsWindow.BackColor:GetTop()+optionsWindow.BackColor:GetHeight()+9);
	optionsWindow.FontCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.FontCaption:SetForeColor(Settings.FontColor);
	optionsWindow.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	optionsWindow.FontColor=ColorPicker();
	optionsWindow.FontColor:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.FontColor:SetPosition(optionsWindow.FontCaption:GetLeft()+optionsWindow.FontCaption:GetWidth()+5,optionsWindow.FontCaption:GetTop()-1);
	optionsWindow.FontColor:SetTrimColor(Settings.TrimColor);
	optionsWindow.FontColor:SetColor(Settings.FontColor);
	optionsWindow.FontColor.ColorChanged=function()
		optionsWindow:SetFontColor(optionsWindow.FontColor:GetColor());
	end

	optionsWindow.ResetColors=Turbine.UI.Lotro.Button();
	optionsWindow.ResetColors:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.ResetColors:SetSize(160,20);
	optionsWindow.ResetColors:SetPosition((optionsWindow.OptionsPanel:GetWidth()-optionsWindow.ResetColors:GetWidth())/2,optionsWindow.FontColor:GetTop()+optionsWindow.FontColor:GetHeight()+9);
	optionsWindow.ResetColors:SetText(Resource[language][9]);
	optionsWindow.ResetColors.Click=function()
		Settings.TrimColor=Turbine.UI.Color(.2,.5,.9);
		Settings.FontColor=Turbine.UI.Color(1,.9,.5);
		Settings.BackColor=Turbine.UI.Color(.05,.05,.05);
		optionsWindow.TrimColor:SetColor(Settings.TrimColor);
		optionsWindow.FontColor:SetColor(Settings.FontColor);
		optionsWindow.BackColor:SetColor(Settings.BackColor);
	end

	optionsWindow.OpacityCaption=Turbine.UI.Label();
	optionsWindow.OpacityCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.OpacityCaption:SetPosition(10,optionsWindow.ResetColors:GetTop()+optionsWindow.ResetColors:GetHeight()+9);
	optionsWindow.OpacityCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.OpacityCaption:SetForeColor(Settings.FontColor);
	optionsWindow.OpacityCaption:SetText(Resource[language][10]..":");
	optionsWindow.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsWindow.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsWindow.OpacityScrollbar:SetParent(optionsWindow.OptionsPanel)
	optionsWindow.OpacityScrollbar:SetPosition(optionsWindow.OpacityCaption:GetLeft()+optionsWindow.OpacityCaption:GetWidth()+5,optionsWindow.OpacityCaption:GetTop());
	optionsWindow.OpacityScrollbar:SetSize(optionsWindow.OptionsPanel:GetWidth()-optionsWindow.OpacityCaption:GetWidth()-optionsWindow.OpacityCaption:GetLeft()-15,10);
	optionsWindow.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsWindow.OpacityScrollbar:SetMinimum(0);
	optionsWindow.OpacityScrollbar:SetMaximum(100);
	optionsWindow.OpacityScrollbar.OriginalValue=100;
	optionsWindow.OpacityScrollbar.ValueChanged=function()
		mainWindow:SetOpacity(optionsWindow.OpacityScrollbar:GetValue()/100);
	end

	optionsWindow.FontListCaption=Turbine.UI.Label();
	optionsWindow.FontListCaption:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.FontListCaption:SetPosition(10,optionsWindow.OpacityCaption:GetTop()+optionsWindow.OpacityCaption:GetHeight()+9);
	optionsWindow.FontListCaption:SetSize(optionsWindow.OptionsPanel:GetWidth()-301,18);
	optionsWindow.FontListCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.FontListCaption:SetForeColor(Settings.FontColor);
	optionsWindow.FontListCaption:SetText(Resource[language][13]..":");

	optionsWindow.FontList=DropDownList();
	optionsWindow.FontList:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.FontList:SetPosition(optionsWindow.FontListCaption:GetLeft()+optionsWindow.FontListCaption:GetWidth()+2,optionsWindow.FontListCaption.GetTop()-3);
	optionsWindow.FontList:SetSize(optionsWindow.OptionsPanel:GetWidth()-(optionsWindow.FontListCaption:GetWidth()+optionsWindow.FontListCaption:GetLeft())-65,20);
	optionsWindow.FontList:SetBorderColor(Settings.TrimColor);
	optionsWindow.FontList:SetBackColor(Settings.BackColor);
	optionsWindow.FontList:SetCurrentBackColor(Settings.BackColor);
	optionsWindow.FontList:SetDropRows(5);
	optionsWindow.FontList:SetZOrder(2)

	local item=1
	local fontList={}
	for k,v in pairs(Turbine.UI.Lotro.Font) do
		if Turbine.UI.Lotro.FontInfo[v]~=nil then
			table.insert(fontList,{Turbine.UI.Lotro.FontInfo[v].name,Turbine.UI.Lotro.FontInfo[v].size,v})
		end
	end
	table.sort(fontList,function(arg1,arg2) if arg1[1]<arg2[1] then return true else if arg1[1]==arg2[1] and arg1[2]<arg2[2] then return true end end end)
	for k,v in ipairs(fontList) do
		optionsWindow.FontList:AddItem("["..tostring(v[2]).."] "..v[1],v[3]);
		local tmpItem=optionsWindow.FontList.ListData:GetItem(item)
		tmpItem:SetHeight(v[2])
		tmpItem:SetFont(v[3])
		tmpItem:SetText(tmpItem:GetText());
		item=item+1
	end

-- Other Options ?
	optionsWindow.DebugCB=Turbine.UI.Lotro.CheckBox();
	optionsWindow.DebugCB:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.DebugCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsWindow.DebugCB:SetForeColor(Settings.FontColor);
	optionsWindow.DebugCB:SetSize(optionsWindow.OptionsPanel:GetWidth()-15,18);
	optionsWindow.DebugCB:SetPosition(10,optionsWindow.FontListCaption:GetTop()+optionsWindow.FontListCaption:GetHeight()+4);
	optionsWindow.DebugCB:SetText("Debug");

	optionsWindow.DebugIcon=Turbine.UI.Label() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
	optionsWindow.DebugIcon:SetParent(optionsWindow.OptionsPanel);
	optionsWindow.DebugIcon:SetSize(optionsWindow.DebugCB:GetSize());
	optionsWindow.DebugIcon:SetPosition(optionsWindow.DebugCB:GetPosition());
	optionsWindow.DebugIcon.MouseClick=function()
		optionsWindow.DebugCB:SetChecked(not optionsWindow.DebugCB:IsChecked());
	end
	optionsWindow.DebugIcon:SetZOrder(optionsWindow.DebugCB:GetZOrder()+1);

--** SAVE AND CANCEL
	optionsWindow.SaveButton=Turbine.UI.Lotro.Button();
	optionsWindow.SaveButton:SetParent(optionsWindow);
	optionsWindow.SaveButton:SetSize(100,20);
	optionsWindow.SaveButton:SetPosition(20,optionsWindow:GetHeight()-40);
	optionsWindow.SaveButton:SetText(Resource[language][11]);
	optionsWindow.SaveButton.Click=function()
		local hasError=false;
		-- validate option values

		if hasError then
			optionsWindow.ErrorLabel:SetVisible(true);
			optionsWindow.HadErrors=true;
			optionsWindow.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			optionsWindow:SetWantsUpdates(true);
		else
			Settings.Debug=optionsWindow.DebugCB:IsChecked();
			debugWindow:SetVisible(Settings.Debug)

			Settings.FontColor=optionsWindow.FontColor:GetColor();
			Settings.TrimColor=optionsWindow.TrimColor:GetColor();
			Settings.BackColor=optionsWindow.BackColor:GetColor();

			local newLanguage=optionsWindow.LanguageList:GetValue();
-- apply colors
			mainWindow.Heading:SetBackColor(Settings.BackColor)
			mainWindow.Heading:SetForeColor(Settings.FontColor)
			Settings.FontFace=optionsWindow.FontList:GetValue()
			local newHeight=Turbine.UI.Lotro.FontInfo[Settings.FontFace].size+2

			mainWindow.fontMetric:SetFont(Settings.FontFace)
			local newWidth=mainWindow.fontMetric:GetTextWidth("Refresh")
			mainWindow:SetSize(newWidth,newHeight)
			mainWindow.Heading:SetSize(newWidth,newHeight)
			mainWindow.CompassQS:SetSize(newWidth,newHeight)
			moveWindow:SetWidth(newWidth)
			moveWindow.MoveText:SetWidth(newWidth-17)

			mainWindow.Heading:SetFont(Settings.FontFace)
			mainWindow.Heading:SetText(mainWindow.Heading:GetText())

			optionsWindow:SetVisible(false);
		end
	end

	optionsWindow.CancelButton=Turbine.UI.Lotro.Button();
	optionsWindow.CancelButton:SetParent(optionsWindow);
	optionsWindow.CancelButton:SetSize(100,20);
	optionsWindow.CancelButton:SetPosition(optionsWindow:GetWidth()-20-optionsWindow.CancelButton:GetWidth(),optionsWindow:GetHeight()-40);
	optionsWindow.CancelButton:SetText(Resource[language][12]);
	optionsWindow.CancelButton.Click=function()
		mainWindow:SetOpacity(optionsWindow.OpacityScrollbar.OriginalValue);
		optionsWindow.FontColor:SetColor(Settings.FontColor);
		optionsWindow.TrimColor:SetColor(Settings.TrimColor);
		optionsWindow.BackColor:SetColor(Settings.BackColor);
		optionsWindow:SetVisible(false);
	end

	optionsWindow.ErrorLabel=Turbine.UI.Label();
	optionsWindow.ErrorLabel:SetParent(optionsWindow);
	optionsWindow.ErrorLabel:SetText("Adjusted Invalid Values")
	optionsWindow.ErrorLabel:SetPosition(optionsWindow.SaveButton:GetLeft()+optionsWindow.SaveButton:GetWidth(),optionsWindow.SaveButton:GetTop());
	optionsWindow.ErrorLabel:SetSize(optionsWindow.CancelButton:GetLeft()-(optionsWindow.ErrorLabel:GetLeft()),optionsWindow.SaveButton:GetHeight());
	optionsWindow.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	optionsWindow.ErrorLabel:SetVisible(false);
	optionsWindow.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	optionsWindow.VisibleChanged=function(sender,args)
		if optionsWindow:IsVisible() then
			-- refresh the options status to reflect current values
			optionsWindow.OpacityScrollbar:SetValue(math.floor(mainWindow:GetOpacity()*100));
			optionsWindow.OpacityScrollbar.OriginalValue=mainWindow:GetOpacity();
			optionsWindow.DebugCB:SetChecked(Settings.Debug);

			local index;
			for index=1,optionsWindow.LanguageList.ListData:GetItemCount() do
				if optionsWindow.LanguageList.ListData:GetItem(index):GetValue()==language then
					optionsWindow.LanguageList:SetSelectedIndex(index);
					break;
				end
			end
			optionsWindow:SetLanguage(language);
			for index=1,optionsWindow.FontList.ListData:GetItemCount() do
				if optionsWindow.FontList.ListData:GetItem(index):GetValue()==Settings.FontFace then
					optionsWindow.FontList:SetSelectedIndex(index);
					break;
				end
			end
			optionsWindow:SetLanguage(language);
		end
	end
	optionsWindow.Update=function(sender,args)
		if optionsWindow.HadErrors then
			if Turbine.Engine:GetGameTime()>optionsWindow.ErrorFadeTime then
				optionsWindow:SetWantsUpdates(false);
				optionsWindow.ErrorLabel:SetVisible(false);
				optionsWindow.HadErrors=false
			end
		end
	end
	optionsWindow.SetTrimColor=function(sender,color)
		optionsWindow.LanguageList:SetBorderColor(color);
		optionsWindow.FontList:SetBorderColor(color)
		optionsWindow.FontColor:SetTrimColor(color);
		optionsWindow.TrimColor:SetTrimColor(color);
		optionsWindow.BackColor:SetTrimColor(color);
	end
	optionsWindow.SetBackColor=function(sender,color)
		optionsWindow.LanguageList:SetBackColor(color);
		optionsWindow.FontList:SetBackColor(color)
		optionsWindow.LanguageList:SetCurrentBackColor(color);
		optionsWindow.FontList:SetCurrentBackColor(color)
		optionsWindow.OptionsPanel:SetBackColor(color);
		optionsWindow.FontColor:SetBackColor(color);
		optionsWindow.TrimColor:SetBackColor(color);
		optionsWindow.BackColor:SetBackColor(color);
	end
	optionsWindow.SetFontColor=function(sender,color)
		optionsWindow.LanguageCaption:SetForeColor(color);
		optionsWindow.FontCaption:SetForeColor(color)
		optionsWindow.TrimCaption:SetForeColor(color);
		optionsWindow.FontListCaption:SetForeColor(color);
		optionsWindow.BackCaption:SetForeColor(color);
		optionsWindow.OpacityCaption:SetForeColor(color);
		optionsWindow.DebugCB:SetForeColor(color)
	end

	optionsWindow.SetLanguage=function(sender,tmpLanguage)
		optionsWindow:SetText(Resource[tmpLanguage][3]);
		optionsWindow.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		optionsWindow.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		optionsWindow.FontListCaption:SetText(Resource[tmpLanguage][13]..":")
		optionsWindow.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		optionsWindow.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		optionsWindow.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		optionsWindow.ResetColors:SetText(Resource[tmpLanguage][9]);
		optionsWindow.OpacityCaption:SetText(Resource[tmpLanguage][10]..":");

		optionsWindow.SaveButton:SetText(Resource[tmpLanguage][11]);
		optionsWindow.CancelButton:SetText(Resource[tmpLanguage][12]);
	end
